from pylab import *

rc('text', usetex=True)
rc('font', family='serif')

n = 500 # number of points over lambda
m = 250 # number of stored y points for a given lambda
k = 1000 # number of not-stored y points to start up

lam = (arange(n, dtype = float) + 1.0) / n * 4

y = empty((n, m), dtype = float)
xp = array(linspace(0, 1, 101))
yp1 = xp * (1 - xp)

for il in range(n):
    l = lam[il]
    x0 = 0.5
    for i in range(k):
        x0 = l * x0 * (1 - x0)
    for i in range(m):
        y[il][i] = x0 = l * x0 * (1 - x0)
    close()
    figure(0, figsize = (6, 6))
    yp = l * yp1
    plot(xp, yp, 'b-')
    plot(xp, xp, 'k-', linewidth = 0.25)
    plot(y[il][:(m - 1)], y[il][1:], 'r.')
    axis([-0.1, 1.1, -0.1, 1.1])
    xlabel(r'$x_k$')
    ylabel(r'$x_{k+1}$')
    title(r'$x_{k+1} = \lambda \, x_k \, (1 - x_k), \; $' + r'$\lambda = {:6.4f}$'.format(l))
    xticks(linspace(0, 1, 11))#, ('$0$', '$0.1$', '$0.2$', '$0.3$', '$0.4$', '$0.5$', '$0.6$', '$0.7$', '$0.8$', '$0.9$', '$1$'))
    yticks(linspace(0, 1, 11))#, ('$0$', '$0.1$', '$0.2$', '$0.3$', '$0.4$', '$0.5$', '$0.6$', '$0.7$', '$0.8$', '$0.9$', '$1$'))
    savefig('may-par-' + str(il) + '.png')

figure(1, figsize = (12, 6))
for i in range(n):
    plot(ones(m) * lam[i], y[i], 'b.', markersize = 1)
xlabel(r'$\lambda$')
ylabel(r'$y_k$')
title(r'$y_{k+1} = \lambda \, y_k \, (1 - y_k)$')
xticks(linspace(0, 4, 9))#, ('$0.0$', '$0.5$', '$1.0$', '$1.5$', '$2.0$', '$2.5$', '$3.0$', '$3.5$', '$4.0$'))
yticks(linspace(0, 1, 6))#, ('$0.0$', '$0.2$', '$0.4$', '$0.6$', '$0.8$', '$1.0$'))
savefig('may.png')



#np.save('lam.npy', lam)
#np.save('y.npy', y)

#f = open('dat.txt', 'w')
#for i in range(n):
#    for j in range(m):
#        f.write(str(lam[i]) + ' ' + str(y[i][j]) + '\n')
#f.close()

